package com.insanityengine.ghia.m3;

/**
 *
 * <P>
 * Goofy math lookup gag
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/m3/MumpMath.java,v 1.5 2005/03/19 17:50:02 brian Exp $
 *
 */

public class MumpMath {
	static int size = 1024 * 4;

	static float cos[] = null;
	static float sin[] = null;

	final static float PI  = ( float ) ( 22.0 / 7.0 );
	final static float PI2 = ( float ) ( 44.0 / 7.0 );

	static float cos( float a ) {	
		if ( null == cos ) init();

		while ( a >= PI2 ) a -= PI2;
		while ( a < 0 ) a += PI2;
		
		if ( !false ) {
			int i = ( int ) ( ( size - 1 ) * ( a / PI2 ) );
			if ( i < 0 || i >= size ) {
				System.out.println( "ack " + i + " with " + a + " v. " + PI2 );
			}
		}
		
		return cos[ ( int ) ( ( size - 1 ) * ( a / PI2 ) ) ];
	}

	static float sin( float a ) {	
		if ( null == sin ) init();

		while ( a >= PI2 ) a -= PI2;
		while ( a < 0 ) a += PI2;
		return sin[ ( int ) ( size * ( a / PI2 ) ) ];
	}

	synchronized static void init() {
		cos = new float[ size ];
		sin = new float[ size ];

		for ( int i = 0 ; i < size ; i++ ) {
			cos[ i ] = ( float ) Math.cos( PI2 * i / ( float ) size );
			sin[ i ] = ( float ) Math.sin( PI2 * i / ( float ) size );
		}
	}
};

/**
 *
 * $Log: MumpMath.java,v $
 * Revision 1.5  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.4  2005/02/17 03:31:13  brian
 * good stuff???
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
