package com.insanityengine.ghia.m3;

/**
 *
 * <P>
 * Big fat thanks to:
 * </P>
 *
 * <UL>
 *	<LI>http://www.gamasutra.com/features/19980703/quaternions_01.htm</LI>
 *  <LI>http://www.macromedia.com/devnet/mx/flash/articles/3d_classes_04.html</LI>
 *	<LI>http://graphics.stanford.edu/courses/cs348c-95-fall/software/quatdemo/</LI>
 *	<LI>http://personal.nbnet.nb.ca/daveg/opengl/</LI>
 * </UL>
 *
 * <P>
 * Their usefulness is due in no small measure to the code artifacts they supplied...
 * Two lines of code can be more useful than 2 pages of text.
 * </P>
 *
 * <P>
 * Here are some that seemed useful, but confused me:
 * </P>
 *
 * <UL>
 *	<LI>http://www.sjbrown.co.uk/quaternions.html</LI>
 *	<LI></LI>
 * </UL>
 *
 * <P>
 * Sadly, it's just still not workin'!
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/m3/Quat.java,v 1.4 2005/03/19 17:50:02 brian Exp $
 *
 */
public class Quat {

	/** 
	 * 
	 * Constructor
	 * 
	 */
	public Quat() {
		set( 0 );
	}

	/** 
	 * 
	 * Constructor
	 * 
	 * @param x
	 * @param y
	 * @param z
	 * 
	 */
	public Quat( float x, float y, float z ) {
		set( x, y, z );
	}

	/** 
	 * 
	 * Constructor
	 * 
	 * @param x
	 * @param y
	 * @param z
	 * @param w
	 * 
	 */
	public Quat( float x, float y, float z, float w ) {
		set( x, y, z, w );
	}

	/** 
	 * 
	 * Constructor
	 * 
	 * @param point
	 * 
	 */
	public Quat( Pt3 point ) {
		set( point );
	}

	/** 
	 * 
	 * Constructor
	 * 
	 * @param that
	 * 
	 */
	public Quat( Quat that ) {
		set( that );
	}

	/** 
	 * 
	 * set
	 * 
	 * @param d
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat set( float d ) {
		return set( d, d, d );
	}

	/** 
	 * 
	 * set
	 * 
	 * @param x
	 * @param y
	 * @param z
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat set( float x, float y, float z ) {
		return set( x, y, z, 0 );
	}

	/** 
	 * 
	 * set
	 * 
	 * @param x
	 * @param y
	 * @param z
	 * @param w
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat set( float x, float y, float z, float w ) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.w = w;
		return this;
	}

	/** 
	 * 
	 * set
	 * 
	 * @param point
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat set( Pt3 point ) {
		return set( point.getX(), point.getY(), point.getZ() );
	}
	
	/** 
	 * 
	 * set
	 * 
	 * @param that
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat set( Quat that ) {
		return set( that.x, that.y, that.z, that.w );
	}

	/** 
	 * 
	 * identity
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat identity() {
		return set( 0, 0, 0, 1 );
	}

	/** 
	 * 
	 * rotate
	 * 
	 * @param angle
	 * @param workspace
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat rotate( Pt3 angle, Quat ws1, Quat ws2, Quat ws3 ) {
/*
		ws1.set( cos( angle.getX() ), sin( angle.getX() ), 0.0f, 0.0f );
		ws2.multiply( this, ws1 ); // ws2 holds result

		ws1.set( cos( angle.getY() ), 0.0f, sin( angle.getY() ), 0.0f );
		ws3.multiply( ws2, ws1 ); // ws3 holds result
		
		ws1.set( cos( angle.getZ() ), 0.0f, 0.0f, sin( angle.getZ() ) );
		this.multiply( ws3, ws1 ); // this holds result
*/		
		if ( false ) {
			ws1.set( cos( angle.getX() ), sin( angle.getX() ), 0.0f, 0.0f );
			ws2.multiply( this, ws1 );
			this.set( ws2 );
		}
		
		return this;
	}

	/** 
	 * 
	 * invert
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat invert() {
		this.x = -this.x;
		this.y = -this.y;
		this.z = -this.z;
		return this;
	}
	
	/** 
	 * 
	 * cos
	 * 
	 * @param f
	 * 
	 * @return a float
	 * 
	 */
	public static final float cos( float f ) {
		return ( float ) Math.cos( f );
	}

	/** 
	 * 
	 * sin
	 * 
	 * @param f
	 * 
	 * @return a float
	 * 
	 */
	public static final float sin( float f ) {
		return ( float ) Math.sin( f );
	}

	/** 
	 * 
	 * translate
	 * 
	 * FIXME: provide an implementation!
	 * 
	 * @param displacement
	 * 
	 * @return this
	 * 
	 */
	public Quat translate( Pt3 displacement ) {
		this.x += displacement.getX();
		this.y += displacement.getY();
		this.z += displacement.getZ();
		return this;
	}

	/** 
	 * 
	 * scale
	 * 
	 * @param ratio
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat scale( Pt3 ratio ) {
		this.x *= ratio.getX();
		this.y *= ratio.getY();
		this.z *= ratio.getZ();
		return this;
	}

	/** 
	 * 
	 * add
	 * 
	 * @param that
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat add( Quat that ) {
		this.x += this.x + that.x;
		this.y += this.y + that.y;
		this.z += this.z + that.z;
		this.w += this.w + that.w;
		return this;
	}

	/** 
	 * 
	 * multiply
	 * 
	 * @param m
	 * @param n
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat multiply( Quat m, Quat n ) {
		this.x = ( m.w * n.x ) + ( m.x * n.w ) + ( m.y * n.z ) - ( m.z * n.y );
		this.y = ( m.w * n.y ) + ( m.y * n.w ) + ( m.z * n.x ) - ( m.x * n.z );
		this.z = ( m.w * n.z ) + ( m.z * n.w ) + ( m.x * n.y ) - ( m.y * n.x );
		this.w = ( m.w * n.w ) - ( m.x * n.x ) - ( m.y * n.y ) - ( m.z * n.z );

		
		//return normalize();
		return this;
	}

	/** 
	 * 
	 * normalize
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat normalize() {
		return divide( safetyLen() );
	}

	/** 
	 * 
	 * multiply
	 * 
	 * @param point
	 * @param destination
	 * 
	 * @return a Pt3
	 * 
	 */
	public Pt3 multiply( Pt3 point, Pt3 destination, Quat ws1, Quat ws2, Quat ws3 ) {
/*

		$q1 = q.copy();
		$q1.invert();
		
		$q2 = new Quaternion();
		$q2.fromPoint($x, $y, $z);
		
		$q3 = q.copy();
		
		$q2.concat($q1);	// q2=point * q1=this.invert
		$q3.concat($q2);	// q3=this  * q2
		// q3 = this * ( point * this.invert() );
		
		$xp = $q3.x;
		$yp = $q3.y;
		$zp = $q3.z;
*/
		//$q2.concat($q1);	// point * this.invert
		ws1.set( this ).invert();
		ws2.set( point );
		ws3.multiply( ws2, ws1 );
			
		//$q3.concat($q2);	// this * ( ws1 )
		ws2.multiply( this, ws3 );
		
		destination.set( 
			  ws2.getX()
			, ws2.getY()
			, ws2.getZ()
		);

		return destination;
	}

	/** 
	 * 
	 * toString
	 * 
	 * @return a String
	 * 
	 */
	public String toString() {
		return (
			super.toString() + "[" +
			"x=" + x + "," +
			"y=" + y + "," +
			"z=" + z + "," +
			"w=" + w + "]" 
		);
	}

	/** 
	 * 
	 * divide
	 * 
	 * @param d
	 * 
	 * @return a Quat
	 * 
	 */
	public Quat divide( float d ) {
		x /= d;
		y /= d;
		z /= d;
		w /= d;
		return this;
	}

	/** 
	 * 
	 * len2
	 * 
	 * @return a float
	 * 
	 */
	public float len2() {
		return (
			+ ( x * x ) 
			+ ( y * y ) 
			+ ( z * z ) 
			+ ( w * w ) 
		);
	}

	/** 
	 * 
	 * safetyLen ( returns length unless 0 (then 1)
	 * 
	 * @return a float
	 * 
	 */
	public float safetyLen() {
		float len = len2();
		if ( 0 == len ) {
			len = 1;
		} else {
			len = ( float ) Math.sqrt( len );
		}
		return len;
	}

	/**
	 *
	 * Get the value of x
	 *
	 * @return the value of x
	 *
	 */
	public final float getX() {
		return x;
	}

	/**
	 *
	 * Set the value of x
	 *
	 * @param newValue of x
	 *
	 */
	public final void setX( float newValue ) {
		x = newValue;
	}

	/**
	 *
	 * Get the value of y
	 *
	 * @return the value of y
	 *
	 */
	public final float getY() {
		return y;
	}

	/**
	 *
	 * Set the value of y
	 *
	 * @param newValue of y
	 *
	 */
	public final void setY( float newValue ) {
		y = newValue;
	}

	/**
	 *
	 * Get the value of z
	 *
	 * @return the value of z
	 *
	 */
	public final float getZ() {
		return z;
	}

	/**
	 *
	 * Set the value of z
	 *
	 * @param newValue of z
	 *
	 */
	public final void setZ( float newValue ) {
		z = newValue;
	}

	/**
	 *
	 * Get the value of w
	 *
	 * @return the value of w
	 *
	 */
	public final float getW() {
		return w;
	}

	/**
	 *
	 * Set the value of w
	 *
	 * @param newValue of w
	 *
	 */
	public final void setW( float newValue ) {
		w = newValue;
	}

	////

	private float x, y, z, w;
	
};

/**
 *
 * $Log: Quat.java,v $
 * Revision 1.4  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.3  2005/03/15 05:45:55  brian
 * closer...
 *
 * Revision 1.2  2005/03/14 00:29:38  brian
 * not quite right..
 *
 * Revision 1.1  2005/03/12 04:51:28  brian
 * right or wrong, here they are...
 *
 *
 */
