package com.insanityengine.ghia.pixels;

/**
 *
 * <P>
 * Interface to map from (x,y) to index space
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/pixels/PixelGetterInterface.java,v 1.2 2005/03/19 17:50:02 brian Exp $
 *
 */

public interface PixelGetterInterface {

	public void setPixels( int w, int h, int pixels[] );

	public int getPixelAt( int x, int y );

};

/**
 *
 * $Log: PixelGetterInterface.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
