package com.insanityengine.ghia.renderer;

import com.insanityengine.ghia.libograf.*;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/renderer/DrawerRegistryInterface.java,v 1.3 2005/03/19 17:50:02 brian Exp $
 *
 */

public interface DrawerRegistryInterface {

	/**
	 *
	 * Some renderers are big babys about when it is ok to mess with their goodies.
	 * Hence this cheesy add/remove Drawer mess
	 *
	 * @param drawer to call per frame
	 *
	 */
	public void addDrawer( DrawingInterface drawer );

	/**
	 *
	 * Some renderers are big babys about when it is ok to mess with their goodies.
	 * Hence this cheesy add/remove Drawer mess
	 *
	 * @param drawer to call per frame
	 *
	 */
	public void removeDrawer( DrawingInterface drawer );

	/**
	 *
	 * Invoke any registered DrawingInterfaces
	 *
	 * @param context to render in
	 *
	 */
	public void invokeDrawers( LiboGraf context );

};

/**
 * 
 * $Log: DrawerRegistryInterface.java,v $
 * Revision 1.3  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.2  2004/09/11 14:37:21  brian
 * added RendererConsumer and stuff
 *
 * Revision 1.1  2004/09/05 03:39:58  brian
 * track those drawingIfz
 *
 * 
 */
