package com.insanityengine.ghia.apps;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

/**
 *
 * <P>
 * Massage those comments into fat ascii text boundary marker
 * </P>
 *
 * @author BrianHammond
 *
 */

public class CommentMassager extends JFrame 
implements ActionListener, ItemListener {
	
	// lamer...
	public final static void main( String argv[] ) {
		CommentMassager l = new CommentMassager( argv );
		l.setVisible( true );
	}	

	public CommentMassager( String argv[] ) {
		super( "CommentMassager" );
		createUI( argv );

		addWindowListener( new WindowAdapter() {
			public void windowClosing( WindowEvent e ) {
				System.exit( 0 );
			}
		} );
	}
	
	// silliness

	public void println( Object o ) {
		System.out.println( o );
	}

	JTextArea area;
	JTextField msg, fnt;
	JCheckBox cbox;


	private void createUI( String argv[] ) {
		Container main = getContentPane();

		JMenuBar menuBar = new JMenuBar();
		setJMenuBar( menuBar );
		
		JMenu menu = new JMenu( "File" );
		menu.setMnemonic( KeyEvent.VK_F );
		menuBar.add( menu );

		JMenuItem menuItem = new JMenuItem( "Quit", KeyEvent.VK_Q );
		menu.add( menuItem );
		menuItem.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit( 0 );
			}
		} );
		
		main.setLayout( new BorderLayout() );

		msg = new JTextField( "TEST" );
		fnt = new JTextField( "TimesRoman.BOLD.12" );

		area = new JTextArea( 12, 80 );
		area.setFont( new Font( "Courier", Font.PLAIN, 12 ) );
		area.setEditable( false );

		JPanel north = new JPanel();
			north.setLayout( new BorderLayout() );

			JPanel weak = new JPanel();
				weak.setLayout( new BorderLayout() );

			JPanel msg_row = new JPanel();
				msg_row.setLayout( new BorderLayout() );
				msg_row.add( new JLabel( "Message" ), BorderLayout.WEST );
				msg_row.add( msg, BorderLayout.CENTER );
			weak.add( msg_row, BorderLayout.NORTH );
			JPanel fnt_row = new JPanel();
				fnt_row.setLayout( new BorderLayout() );
				fnt_row.add( new JLabel( "Font"  ), BorderLayout.WEST );
				fnt_row.add( fnt, BorderLayout.CENTER );
			weak.add( fnt_row, BorderLayout.SOUTH );
			
		north.add( weak, BorderLayout.CENTER );
		JButton butt = new JButton( "[ATTACK]" );
			butt.addActionListener( this );

		north.add( butt, BorderLayout.EAST );
		main.add( north, BorderLayout.NORTH );

		cbox = new JCheckBox( "Use Hashes not Slashes" );
		cbox.addItemListener( this );
		JPanel south = new JPanel();
			south.add( cbox );
			//south.add( new JLabel( "Use Hashes not Slashes" ) );
		main.add( south, BorderLayout.SOUTH );

		main.add( area, BorderLayout.CENTER );

		pack();
	}

	Image img = null;
	Graphics g = null;
	int w, h;

	int pixels[] = null;
	boolean hash = false;

	public void itemStateChanged( ItemEvent e ) {
		hash = !hash;
	}

	public void actionPerformed(ActionEvent e) {
		String msg_str = msg.getText();
		String fnt_str = fnt.getText();

		w = 400;
		h = 64;


		if ( null == img ) {
			img = createImage( w, h );
			g = img.getGraphics();
			pixels = new int[ w * h ];
		}
		if ( null == img ) {
			area.setText( "boohoo... could not create image..." );
			return;
		}

		StringTokenizer st = new StringTokenizer( fnt_str, "." );
		String fname = "TimesRoman";
		int ftype = Font.BOLD;
		int fsize = 12;
			
		String str;
		str = st.nextToken();
		if ( null != str ) fname = str;

		str = st.nextToken();
		if ( null != str ) {
			switch( str.charAt( 0 ) ) {
				case 'B': ftype = Font.BOLD; break;
				//case 'I': ftype = Font.ITALICS; break;
				case 'P': ftype = Font.PLAIN; break;
			}
		}

		str = st.nextToken();
		if ( null != str ) {	
			try {
				fsize = Integer.valueOf( str ).intValue();
			} catch ( Exception eee ) {
			}
		}
		System.out.println( "" + " fname = " + fname  + " ftype = " + ftype  + " fsize = " + fsize );


		Font f = new Font( fname, ftype, fsize );
		if ( null != f ) g.setFont( f );
		else System.out.println( "bad font!" );

		System.out.println( "msg_str = " + msg_str  + " fnt_str = " + fnt_str );

		g.setColor( Color.white );
		g.fillRect( 0, 0, w, h );
		g.setColor( Color.black );
		g.drawString( msg_str, 0, 20 );

	
		PixelGrabber pg;
     	pg = new PixelGrabber( img.getSource(), 0, 0, w, h, pixels, 0, w );
        try { 
			pg.grabPixels(); 
		} catch ( Exception egg ) {
			egg.printStackTrace();
			return;
		}

		int max = w * h;
		int i, j, idx;

		int x1, y1;
		int x2, y2;

		x2 = y2 = -1;
		x1 = y1 = w + h;

		for ( i = idx = 0 ; i < h ; i++ ) {
			for ( j = 0 ; j < w ; j++, idx++ ) {
				if ( -1 != pixels[ idx ] ) {
				
					if ( j > x2 ) x2 = j;
					if ( i > y2 ) y2 = i;

					if ( j < x1 ) x1 = j;
					if ( i < y1 ) y1 = i;
				}
			}
		}
System.out.println( "" + " x1 = " + x1  + " y1 = " + y1  + " x2 = " + x2  + " y2 = " + y2 );


		String add;
		String com = "//";
		String spc = "  ";
		
		if ( hash ) { 
			com = "#";
			spc = " ";
		}

		area.setText( "" );

		for ( i = y1 ; i <= y2 ; i++ ) {

			for ( j = x1 ; j <= x2 ; j++ ) {
				idx = j + i * w;

				if ( -1 != pixels[ idx ] ) add = com;
				else add = spc;

				area.append( add );
				System.out.print( add );
			}
			area.append( "\n" );
			System.out.println();
			
		}
	}
};

/**
 *
 * $Log: CommentMassager.java,v $
 * Revision 1.4  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
