package com.insanityengine.ghia.m3;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/m3/Extent2dInterface.java,v 1.5 2005/03/27 00:09:45 brian Exp $
 *
 */

public interface Extent2dInterface {

	/**
	 *
	 * Determines the width of the object. 
	 *
	 * @return the width of this object
	 *
	 */
	public int getWidth();

	/**
	 *
	 * Determines the height of the object. 
	 *
	 * @return the height of this object
	 *
	 */
	public int getHeight();
	
	/**
	 *
	 * Set the width of the object. 
	 *
	 * @param width to set to
	 *
	 */
	public void setWidth( int width );

	/**
	 *
	 * Set the height of the object. 
	 *
	 * @param height of this object
	 *
	 */
	public void setHeight( int height );

};

/**
 *
 * $Log: Extent2dInterface.java,v $
 * Revision 1.5  2005/03/27 00:09:45  brian
 * remove goofy link
 *
 * Revision 1.4  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.3  2004/09/03 03:35:35  brian
 * removed "final" modifier...
 *
 * Revision 1.2  2004/09/03 03:25:39  brian
 * get/set... 
 *
 *
 */
