package com.insanityengine.ghia.model;

import com.insanityengine.ghia.m3.*;
import com.insanityengine.ghia.libograf.*;

/**
 *
 * <P>
 * Guess what this does...
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/model/Cube.java,v 1.5 2005/03/19 17:50:02 brian Exp $
 *
 */

public class Cube implements DrawingInterface {

	/**
	 *
	 * Constructor
	 *
	 */
	public Cube() {}

	/**
	 *
	 * Do some kinda drawing thang
	 *
	 * @param gl context to draw in
	 *
	 */
	public final void draw( LiboGrafInterface gl ) {
		cube( gl );
	}

	////////////////////////////////////////////////////////////
	
	/**
	 *
	 * Draw a cube at given location... kinda lame...
	 *
	 */
	public static final void cube( LiboGrafInterface gl ) {

		gl.startPolygon();
			gl.textCoord( 0, 0 ); gl.addPoint( pt0 );
			gl.textCoord( 1, 0 ); gl.addPoint( pt1 );
			gl.textCoord( 1, 1 ); gl.addPoint( pt2 );
			gl.textCoord( 0, 1 ); gl.addPoint( pt3 );
		gl.stopPolygon();

		gl.startPolygon();
			gl.textCoord( 0, 0 ); gl.addPoint( pt4 );
			gl.textCoord( 1, 0 ); gl.addPoint( pt5 );
			gl.textCoord( 1, 1 ); gl.addPoint( pt1 );
			gl.textCoord( 0, 1 ); gl.addPoint( pt0 );
		gl.stopPolygon();

		gl.startPolygon();
			gl.textCoord( 0, 0 ); gl.addPoint( pt2 );
			gl.textCoord( 1, 0 ); gl.addPoint( pt1 );
			gl.textCoord( 1, 1 ); gl.addPoint( pt5 );
			gl.textCoord( 0, 1 ); gl.addPoint( pt6 );
		gl.stopPolygon();

		gl.startPolygon();
			gl.textCoord( 0.0f, 0.0f ); gl.addPoint( pt2 );
			gl.textCoord( 0.5f, 0.0f ); gl.addPoint( pt6 );
			gl.textCoord( 0.5f, 0.5f ); gl.addPoint( pt7 );
			gl.textCoord( 0.0f, 0.5f ); gl.addPoint( pt3 );
		gl.stopPolygon();

		gl.getRenderer().setTextureFunction( M3_Constants.TEXT_CLAMP );
		gl.startPolygon();
			gl.textCoord( 0, 0 ); gl.addPoint( pt0 );
			gl.textCoord( 2, 0 ); gl.addPoint( pt3 );
			gl.textCoord( 2, 2 ); gl.addPoint( pt7 );
			gl.textCoord( 0, 2 ); gl.addPoint( pt4 );
		gl.stopPolygon();

		gl.getRenderer().setTextureFunction( M3_Constants.TEXT_WRAP );
		gl.startPolygon();
			gl.textCoord( 0, 0 ); gl.addPoint( pt7 );
			gl.textCoord( 2, 0 ); gl.addPoint( pt6 );
			gl.textCoord( 2, 2 ); gl.addPoint( pt5 );
			gl.textCoord( 0, 2 ); gl.addPoint( pt4 );
		gl.stopPolygon();
	}

	/**
	 *
	 * Draw a cube at given location... kinda lame...
	 *
	 * @param gl to draw with
	 * @param x coordinate
	 * @param y coordinate
	 * @param z coordinate
	 *
	 */
	public final static void cubeAt( LiboGrafInterface gl, float x, float y, float z ) {
		gl.push(); 
			gl.translate( displacement.set( x, y, z ) );
			Cube.cube( gl );
		gl.pop();
	}
	
	////////////////////////////////////////////////////////////

	private final static Pt3 pt = new Pt3();

	private final static Pt3 pt0 = new Pt3( -1.0f, -1.0f,  1.0f );
	private final static Pt3 pt1 = new Pt3( -1.0f,  1.0f,  1.0f );
	private final static Pt3 pt2 = new Pt3(  1.0f,  1.0f,  1.0f );
	private final static Pt3 pt3 = new Pt3(  1.0f, -1.0f,  1.0f );
	private final static Pt3 pt4 = new Pt3( -1.0f, -1.0f, -1.0f );
	private final static Pt3 pt5 = new Pt3( -1.0f,  1.0f, -1.0f );
	private final static Pt3 pt6 = new Pt3(  1.0f,  1.0f, -1.0f );
	private final static Pt3 pt7 = new Pt3(  1.0f, -1.0f, -1.0f );

	private static Pt3 displacement = new Pt3();

};

/**
 *
 * $Log: Cube.java,v $
 * Revision 1.5  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.4  2005/03/11 23:35:31  brian
 * major refactoring to add in com.insanityengine.ghia.libograf.State bitz
 *
 * Revision 1.3  2005/03/10 13:31:19  brian
 * introduce com.insanityengine.ghia/libograf/State to pave the way for quaternions based LiboGrafInterface implementation
 *
 * Revision 1.2  2004/09/11 19:32:29  brian
 * effects of adding LiboGrafInterface
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.6  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.5  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
