package com.insanityengine.ghia.model;

import com.insanityengine.ghia.m3.*;

/**
 *
 * <P>
 * Some kinda mesh 
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/model/MishMesh.java,v 1.2 2005/03/19 17:50:02 brian Exp $
 *
 */

public class MishMesh {
	Pt3 ptz[];
	Pt3 trz[];

	int tri[]; // secret 2d array of 3 indexes into pts...

	// normal fun
	Pt3 normalz[];
	
	Mat4 localMat = new Mat4();

	MishMesh() {
		ptz = null;
		trz = null;
	}
	
	void vStart( int n ) {
		ptz = new Pt3[ n ];
		trz = new Pt3[ n ];
		for ( int i = 0 ; i < n ; i++ ) {
			trz[ i ] = new Pt3();
		}
	}
	void setV( int i, float x, float y, float z ) {
		ptz[ i ] = new Pt3( x, y, z );
	}
	void setM( int i, float s, float t ) {
		ptz[ i ].s = s;
		ptz[ i ].t = t;
	}

	void tStart( int n ) {
		tri = new int[ 3 * n ];
		normalz = new Pt3[ n ];
		for ( int i = 0 ; i < n ; i++ ) normalz[ i ] = new Pt3();
	}
	void setT( int i, int v1, int v2, int v3 ) {
			
	}

	
};

/**
 *
 * $Log: MishMesh.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
