package com.insanityengine.ghia.renderer;

import com.insanityengine.ghia.libograf.*;

import java.util.*;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/renderer/DrawerRegistry.java,v 1.2 2005/03/19 17:50:02 brian Exp $
 *
 */

public class DrawerRegistry implements DrawerRegistryInterface {

	public DrawerRegistry() {}
	
	/**
	 *
	 * Some renderers are big babys about when it is ok to mess with their goodies.
	 * Hence this cheesy add/remove Drawer mess
	 *
	 * @param drawer to call per frame
	 *
	 */
	public void addDrawer( DrawingInterface drawer ) {
		drawers.put( drawer, drawer );
	}

	/**
	 *
	 * Some renderers are big babys about when it is ok to mess with their goodies.
	 * Hence this cheesy add/remove Drawer mess
	 *
	 * @param drawer to call per frame
	 *
	 */
	public void removeDrawer( DrawingInterface drawer ) {
		drawers.remove( drawer );
	}

	/**
	 *
	 * Invoke any registered DrawingInterfaces
	 *
	 */
	public void invokeDrawers( LiboGraf gl ) {
		for ( Enumeration e = drawers.elements() ; e.hasMoreElements() ; ) {
			( ( DrawingInterface ) e.nextElement() ).draw( gl );
		}
	}

	////////////////////////////////////////

	private Hashtable drawers = new Hashtable();
};

/**
 * 
 * $Log: DrawerRegistry.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/05 03:39:58  brian
 * track those drawingIfz
 *
 * 
 */
